## fclib 3.0.0%2Bdfsg

=== src/Makefile ===
include Config.mak

ifeq ($(DEBUG),yes)
  DEBUG =  -W -Wall -Wno-unused-parameter -g -DDEBUG # -pedantic
else
  DEBUG =  -w -O
endif

ifneq ($(SUITESPARSE_DIR),)
  SUITESPARSE_INC = -I$(SUITESPARSE_DIR)
  LIB += $(SUITESPARSE_LIB) -lm
endif

CFLAGS = $(STD) $(DEBUG) $(SUITESPARSE_INC) $(DEFS) $(HDF5INC) $(MPIINC)

LIB += $(HDF5LIB) $(MPILIB)

OBJ =  fclib.o $(SUITESPARSE_OBJ)

all: ./tests/fctest1 ./tests/fctst_merit

./tests/fctest1: ./tests/fctst.o libfclib.a
	$(CC) $(PROFILE) -o $@ $< -L. -lfclib $(LIB)

./tests/fctst_merit: ./tests/fctst_merit.o libfclib.a
	$(CC) $(PROFILE) -o $@ $< -L. -lfclib $(LIB)

libfclib.a: $(OBJ)
	ar rcv $@ $(OBJ)
	ranlib $@ 

clean:
	rm -f ./tests/fctst
	rm -f ./tests/*.o
	rm -f *.o
	rm -f *.a

./tests/fctst.o: ./tests/fctst.c 
	$(CC) $(CFLAGS) -I. -c -o $@ $<

./tests/fctst_merit.o: ./tests/fctst_merit.c
	$(CC) $(CFLAGS) -I. -c -o $@ $<

$(SUITESPARSE_OBJ): $(SUITESPARSE_DIR)/csparse.c
	$(CC) $(CFLAGS) -I. -c -o $@ $<

fclib.o: fclib.c fclib.h
	$(CC) $(CFLAGS) -c -o $@ $<

test:
	./fctst

.PHONY: clean all test

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)

%:
	dh $@

# Notes: remove rpath due to Debian policy
override_dh_auto_configure:
	dh_auto_configure -- \
	  -DCMAKE_SKIP_BUILD_RPATH=TRUE \
	  -DFORCE_SKIP_RPATH=1 \
	  -DCMAKE_SKIP_INSTALL_RPATH=TRUE \
	  -DCMAKE_SKIP_RPATH=TRUE \
	  -DFCLIB_WITH_MERIT_FUNCTIONS=ON \
	  -DFCLIB_HEADER_ONLY=OFF \
	  -DHARDCODE_NOT_HEADER_ONLY=ON \
	  -DINSTALL_CMAKE_DIR=$(LIBDIR)/cmake/FCLib

## fclib 3.0.0+dfsg

=== CMakeLists.txt ===
# =================================================================
# cmake configuration to compile and install fclib library
# =================================================================

#
# Global cmake Settings 
#

# Set minimum version for cmake
cmake_minimum_required(VERSION 2.8)

# Set policy
cmake_policy(VERSION 2.8)

# Set cmake modules directory (i.e. the one which contains all
# user-defined FindXXX.cmake files among other things)
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/CMake)

# debug
macro(display V)
  message(STATUS "${V} = ${${V}}")
endmacro(display V)

MACRO(ASSERT VAR)
  IF (NOT DEFINED ${VAR})
    MESSAGE( FATAL_ERROR "ASSERTION ERROR : ${VAR} UNSET" )
  ENDIF()
ENDMACRO()

IF(APPLE)
  SET (CMAKE_OSX_ARCHITECTURES "i386;x86_64" )
ENDIF(APPLE)

# User defined options
option(FCLIB_WITH_MERIT_FUNCTIONS "enable merit functions. Default = ON" OFF)
option(FCLIB_HEADER_ONLY "static interface. Default = ON" ON)
option(VERBOSE_MODE "enable verbose mode for cmake exec. Default = ON" ON)
option(USE_MPI "compile and link fclib with mpi when this mode is enable. Default = ON" OFF)
option(BUILD_SHARED_LIBS "Enable dynamic library build, default = ON" ON)
option(WITH_TESTS "Enable testing. Default = ON" ON)
option(FORCE_SKIP_RPATH "Do not build shared libraries with rpath. Useful only for packaging. Default = OFF" OFF)
option(USE_SYSTEM_SUITESPARSE "Use the system-installed SuiteSparse library for CXSparse if one is found." ON)
option(SKIP_PKGCONFIG "Do not configure or install the pkg-config file." OFF)
option(HARDCODE_NOT_HEADER_ONLY "Pre-define as 'not header-only' in the installed header." OFF)

# cmake project name
set(PROJECT_NAME fclib)

# This name will be used to install FCLib (library, headers, ...) and
# when another lib or soft will need to search for FCLib.
set(PACKAGE_NAME "FCLib")

# --- Set a version number for the package ---
set(${PACKAGE_NAME}_version 3.0.0)
set(PACKAGE_VERSION ${${PACKAGE_NAME}_version})

# --- The name (without extension) of the lib to be created ---
set(PROJECT_LIBRARY_NAME ${PROJECT_NAME})

# The list of all dirs containing sources to be compiled for the fclib lib
# Any file in those dirs will be used to create libfclib
if(FCLIB_WITH_MERIT_FUNCTIONS)
  set(${PROJECT_LIBRARY_NAME}_SRCDIRS "src;externals/SuiteSparse/CSparse")
else()
  set(${PROJECT_LIBRARY_NAME}_SRCDIRS "src")
endif()

# Matching expr for files to be compiled. 
set(EXTS *.c)

# Matching expr for headers (install purpose)
set(EXTS_HDRS *.h)

# ============= ABI version =============
### SOVERSION
#
# The ${${PACKAGE_NAME}_version} variable above indicates API
# compatibility, whereas the ${PACKAGE_NAME}_SOVERSION (or SONAME),
# below, indicates ABI compatibility.
#
# To be bumped at each release, by the following rules.  If you are
# not sure, likely API and ABI compatibility have both been
# sacrificed, so simply bump SO_current and set the others to zero.
# If an effort has been made to be backwards compatible on this
# release (e.g. bug fix release), continue with the rules outlined
# below.
#
### RULES for SONAME (borrowed from libtool)
### https://www.gnu.org/software/libtool/manual/html_node/Libtool-versioning.html
#
# If the library source code has changed at all since the last update, then
# increment revision (`c:r:a' becomes `c:r+1:a').
#
# If any interfaces have been added, removed, or changed since the last update,
# increment current, and set revision to 0.
#
# If any interfaces have been added since the last public release, then
# increment age.
#
# If any interfaces have been removed since the last public release, then set
# age to 0.

set(SO_current 0)
set(SO_revision 0)
set(SO_age 0)

# Aggregate variables, to be passed to linker.
# libraries will be named e.g.,
#   libfclib.so -> libfclib.so.5 -> libfclib.so.5.0.0
# Again: this is *not* the software release number!
set(SO_version_info "${SO_current}:${SO_revision}:${SO_age}")
math(EXPR SO_current_minus_age "(${SO_current}) - (${SO_age})")
set(${PACKAGE_NAME}_SOVERSION "${SO_current_minus_age}.${SO_revision}.${SO_age}" CACHE STRING "Fclib SONAME")
set(${PACKAGE_NAME}_SOVERSION_MAJOR "${SO_current_minus_age}" CACHE STRING "fclib SONAME current-minus-age")


# ============= The project =============
# Set project name and project languages 
# => this automatically defines:
#   - ${PROJECT_NAME}_BINARY_DIR : where you have run cmake, i.e. the place for compilation
#   - ${PROJECT_NAME}_SOURCE_DIR : where sources (.f and .h and this CMakeLists.txt) are located
# Note that because of OutOfSourceBuild, binary_dir and source_dir must be different. 
project(${PROJECT_NAME} C)

# Install lib directory 32, 64 etc. on Fedora, Debian 
# http://public.kitware.com/Bug/view.php?id=11964
# See also http://www.cmake.org/cmake/help/v3.0/module/GNUInstallDirs.html?highlight=gnuinstalldirs
include(GNUInstallDirs)
# Set prefix path for libraries installation
# --> means that any library target will be installed
# in CMAKE_INSTALL_PREFIX/_install_lib
if(${PROJECT_NAME}_INSTALL_LIB_DIR)
  set(_install_lib ${${PROJECT_NAME}_INSTALL_LIB_DIR})
else()
  ASSERT(CMAKE_INSTALL_LIBDIR)
  set(_install_lib ${CMAKE_INSTALL_LIBDIR})
  set(${PROJECT_NAME}_INSTALL_LIB_DIR ${_install_lib})
endif()


# --- RPATH stuff ---
# See https://cmake.org/Wiki/CMake_RPATH_handling
# Warning: RPATH settings must be defined before install(...) settings.
if(FORCE_SKIP_RPATH)
  set(CMAKE_SKIP_BUILD_RPATH TRUE)
else()
  set(CMAKE_SKIP_BUILD_RPATH FALSE)
endif()

# when building, don't use the install RPATH already
# (but later on when installing)
set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE) 

# when building a binary package, it makes no sense to add this rpath
if(NOT FORCE_SKIP_RPATH)
  # the RPATH to be used when installing
  set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
endif(NOT FORCE_SKIP_RPATH)

# don't add the automatically determined parts of the RPATH
# which point to directories outside the build tree to the install RPATH
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

# The following settings were copied from
# https://cmake.org/Wiki/CMake_RPATH_handling
# to avoid the rpath issue that appears on OS X El Capitan

# the RPATH to be used when installing, but only if it's not a system directory
list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib" isSystemDir)
if("${isSystemDir}" STREQUAL "-1")
  set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${_install_lib}")
endif()

# ============= Doc and website =============
# Doxygen documentation
if(WITH_DOCUMENTATION)
  include(FCLibDoc)
endif(WITH_DOCUMENTATION)


include(FeatureSummary)

# ============= Search for libraries  =============
# set the compile/link conf (-I and -L opt)

# --- hdf5 --- what a mess!, cf this thread
# http://www.cmake.org/pipermail/cmake/2011-June/044723.html
find_package(HDF5 REQUIRED COMPONENTS HL)

#set(HDF5_INCLUDE_DIRS "/opt/local/include/")
include_directories(${HDF5_INCLUDE_DIRS})

set(LIBS ${LIBS} ${HDF5_LIBRARIES} ${HDF5_HL_LIBRARIES})
display(HDF5_INCLUDE_DIRS)

if(FCLIB_WITH_MERIT_FUNCTIONS)
  add_definitions("-DFCLIB_WITH_MERIT_FUNCTIONS")
endif()

if(NOT FCLIB_HEADER_ONLY)
  add_definitions("-DFCLIB_NOT_HEADER_ONLY")
endif()

# --- MPI ---
if(USE_MPI)
  # Find MPI for C++ and fortran.
  find_package(MPI REQUIRED)
  if(MPI_COMPILER)
    set(CMAKE_CXX_COMPILER mpic++)
    set(CMAKE_C_COMPILER mpicc)
  elseif(MPI_COMPILER)
    # -I
    include_directories(${MPI_INCLUDE_PATH})
    # Add compilation flags
    append_c_flags(${MPI_COMPILE_FLAGS})
    set(${PROJECT_NAME}_LINK_FLAGS ${${PROJECT_NAME}_LINK_FLAGS} ${MPI_LINK_FLAGS})
  endif(MPI_COMPILER)
  set(LIBS ${LIBS} ${MPI_LIBRARIES} )
endif(USE_MPI)

# --- SuiteSparse (for CXSparse) ---
if(USE_SYSTEM_SUITESPARSE)
if(FCLIB_WITH_MERIT_FUNCTIONS)
  find_package(SuiteSparse OPTIONAL_COMPONENTS CXSparse)
  if (SuiteSparse_CXSparse_FOUND)
    set(${PROJECT_LIBRARY_NAME}_SRCDIRS "src")
    set(LIBS ${LIBS} ${CXSparse_LIBRARY})
    include_directories(${SuiteSparse_INCLUDE_DIRS})
    message(STATUS "CXSparse: ${CXSparse_LIBRARY}")
  else()
    message(STATUS "Using built-in CSparse")
  endif()
endif()
endif()

# ============= Prepare compilation =============
# Force a default build type if not provided by user
# CMAKE_BUILD_TYPE = empty, Debug, Release, RelWithDebInfo or MinSizeRel.
if (NOT CMAKE_BUILD_TYPE)
  set (CMAKE_BUILD_TYPE RELEASE CACHE STRING "Choose the type of build, options are: None, Debug, Release, RelWithDebInfo or MinSizeRel." FORCE)  
endif (NOT CMAKE_BUILD_TYPE)

if(MSVC)
  option(USING_HDF5_DLLs "WIN ONLY: turn on if the shared library of HDSL is linked" ON)
  IF (USING_HDF5_DLLs)
    ADD_DEFINITIONS("-DH5_BUILT_AS_DYNAMIC_LIB")
  ENDIF(USING_HDF5_DLLs)
  ADD_DEFINITIONS("-DFCLIB_APICOMPILE=__declspec( dllexport )")
  ADD_DEFINITIONS("-D_CRT_SECURE_NO_WARNINGS")
endif(MSVC)

# ============= Source and header files list =============
# We scan all files with matching extension in directories 
# containing sources.
# Source and header files list:
foreach(_DIR ${${PROJECT_LIBRARY_NAME}_SRCDIRS})
  set(_DIR_FILES)
  foreach(_EXT ${EXTS}) # Source files
    file(GLOB _DIR_FILES_EXT ${_DIR}/${_EXT})
    if(_DIR_FILES_EXT)
      list(APPEND ${PROJECT_LIBRARY_NAME}_SRC ${_DIR_FILES_EXT})
    endif()
  endforeach()
  foreach(_EXT ${EXTS_HDRS}) # Headers
    file(GLOB _DIR_FILES_EXT ${_DIR}/${_EXT})
    if(_DIR_FILES_EXT)
      list(APPEND ${PROJECT_LIBRARY_NAME}_HDRS ${_DIR_FILES_EXT})
    endif()
  endforeach()
endforeach()

if(HARDCODE_NOT_HEADER_ONLY)
  if(FCLIB_HEADER_ONLY)
    message(FATAL_ERROR
      "HARDCODE_NOT_HEADER_ONLY=${HARDCODE_NOT_HEADER_ONLY} "
      "and FCLIB_HEADER_ONLY=${FCLIB_HEADER_ONLY} are inconsistent.")
  endif()
  set(OPTDEFS FCLIB_NOT_HEADER_ONLY)
  if(FCLIB_WITH_MERIT_FUNCTIONS)
    set(OPTDEFS "${OPTDEFS};FCLIB_WITH_MERIT_FUNCTIONS")
  endif()
  set(DEFS)
  foreach(_D ${OPTDEFS})
    set(DEFS "${DEFS}\\n#ifndef ${_D}\\n#define ${_D}\\n#endif\\n")
  endforeach()
  add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/fclib.h
    COMMAND cat ${CMAKE_CURRENT_SOURCE_DIR}/src/fclib.h
      | sed 's,/\\*@ CONFIG @\\*/,${DEFS},'
      | sed '/@@/,/@@/d'
      | sed 's/FCLIB_STATIC //' >fclib.h
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/src/fclib.h
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Customising fclib.h")
  list(REMOVE_ITEM ${PROJECT_LIBRARY_NAME}_HDRS "${CMAKE_SOURCE_DIR}/src/fclib.h")
  list(APPEND ${PROJECT_LIBRARY_NAME}_HDRS "${CMAKE_BINARY_DIR}/fclib.h")
endif()

# We add headers to source files
list(APPEND ${PROJECT_LIBRARY_NAME}_SRC ${${PROJECT_LIBRARY_NAME}_HDRS})

# Add directories to those searched by compiler ...
# -I
include_directories(${${PROJECT_LIBRARY_NAME}_SRCDIRS})

# ============= Creates the library =============
if (FCLIB_WITH_MERIT_FUNCTIONS OR NOT FCLIB_HEADER_ONLY)
  if(BUILD_SHARED_LIBS) # shared library
    add_library(${PROJECT_LIBRARY_NAME} SHARED ${${PROJECT_LIBRARY_NAME}_SRC})
  else() # static library
    add_library(${PROJECT_LIBRARY_NAME} STATIC ${${PROJECT__LIBRARY_NAME}_SRC})
  endif()
  # Libs to link with PROJECT__LIBRARY_NAME
  target_link_libraries(${PROJECT_LIBRARY_NAME} ${LIBS})

  set_target_properties(${PROJECT_LIBRARY_NAME} PROPERTIES
    OUTPUT_NAME "${PROJECT_LIBRARY_NAME}"
    VERSION "${${PACKAGE_NAME}_SOVERSION}"
    SOVERSION  "${${PACKAGE_NAME}_SOVERSION_MAJOR}"
    CLEAN_DIRECT_OUTPUT 1 # no clobbering
    LINKER_LANGUAGE C)
endif()
# ============== Add tests ==============

FILE(GLOB_RECURSE _DATA_FILES 
  RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}/${_D}
  *.hdf5
  *.mat 
  *.dat
  *.xml
  *.DAT
  *.INI)

FOREACH(_F ${_DATA_FILES})
  IF (NOT "${_F}" MATCHES "fclib-library")
    GET_FILENAME_COMPONENT(_BASENAME_F "${_F}" NAME )
    MESSAGE(STATUS "basename = ${_BASENAME_F}")
    MESSAGE(STATUS "copy  ${CMAKE_CURRENT_SOURCE_DIR}/${_D}/${_F} in ${CMAKE_CURRENT_BINARY_DIR}/${_BASENAME_F}")

=== debian/changelog ===
fclib (3.0.0+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Standards-Version: 4.2.1
  * Remove hard-coded lib and lib-dev dependencies from lib package.
    Closes: #914493.

 -- Drew Parsons <dparsons@debian.org>  Tue, 04 Dec 2018 10:44:49 +0800

fclib (3.0.0+dfsg-1) unstable; urgency=medium

  * Initial release. (Closes: #894120)

 -- Stephen Sinclair <radarsat1@gmail.com>  Mon, 26 Mar 2018 12:40:15 -0300

=== debian/control ===
Source: fclib
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Stephen Sinclair <radarsat1@gmail.com>
Section: science
Priority: optional
Build-Depends: debhelper (>= 11),
               cmake (>= 3.0.2),
               libhdf5-dev (>= 1.10),
               libsuitesparse-dev (>= 1:5.1.2)
Standards-Version: 4.2.1
Vcs-Browser: https://salsa.debian.org/science-team/fclib
Vcs-Git: https://salsa.debian.org/science-team/fclib.git
Homepage: https://frictionalcontactlibrary.github.io/
Rules-Requires-Root: no

Package: libfclib0
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: read and write problems from the Friction Contact Library (library)
 fclib is an open source collection of Frictional Contact (FC)
 problems stored in a specific HDF5 format, and an open source light
 implementation of Input/Output functions in C Language to read and
 write problems.
 .
 The goal of this work is to set up a collection of 2D and 3D
 Frictional Contact (FC) problems in order to set up a list of
 benchmarks; provide a standard framework for testing available and
 new algorithms; and share common formulations of problems in order to
 exchange data.
 .
 Fclib is an open-source scientific software primarily targeted at
 modeling and simulating nonsmooth dynamical systems
 .
 This package includes the libfclib libraries.

Package: libfclib-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libfclib0 (= ${binary:Version}),
         libhdf5-dev (>= 1.10),
         libsuitesparse-dev (>= 1:5.1.2)
Description: read and write problems from the Friction Contact Library (headers)
 fclib is an open source collection of Frictional Contact (FC)
 problems stored in a specific HDF5 format, and an open source light
 implementation of Input/Output functions in C Language to read and
 write problems.
 .
 The goal of this work is to set up a collection of 2D and 3D
 Frictional Contact (FC) problems in order to set up a list of
 benchmarks; provide a standard framework for testing available and
 new algorithms; and share common formulations of problems in order to
 exchange data.
 .
 Fclib is an open-source scientific software primarily targeted at
 modeling and simulating nonsmooth dynamical systems
 .
 This package includes the libfclib development headers.

=== debian/tests/control ===
Tests: unittests-pkgconfig
Depends: libfclib-dev, build-essential, pkg-config

Tests: unittests-cmake
Depends: libfclib-dev, build-essential, cmake

## fclib 3.1.0%2Bdfsg

=== debian/changelog ===
fclib (3.1.0+dfsg-2build1) impish; urgency=medium

  * No-change upload to drop reference to libpthread.so.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 17 Aug 2021 12:03:34 +0200

fclib (3.1.0+dfsg-2) unstable; urgency=medium

  * Patch wrong argument to cs_transpose which leads to segfault.
    (Closes: #927761)

 -- Stephen Sinclair <radarsat1@gmail.com>  Thu, 11 Jun 2020 21:29:28 +0000

fclib (3.1.0+dfsg-1) unstable; urgency=medium

  * New upstream version.
  * Change paths to correspond with new CMake install location.
  * Make unittests-cmake test the FCLIB exported target.
  * Hardcode path to cs.h from libsuitesparse-dev.
  * Add Upstream-Contact info to debian/copyright.
  * Increase policy standard to 4.5.0.
    + d/copyright: add wildcard for Files-Excluded
  * Add Build-Depends-Package field to symbols files.

 -- Stephen Sinclair <radarsat1@gmail.com>  Tue, 19 May 2020 11:36:51 +0000

## fclib 3.1.0+dfsg

=== CMakeLists.txt ===
# =================================================================
# cmake configuration to compile and install fclib library
# =================================================================

#
# ------ Global cmake Settings -------
#
# Set minimum version for cmake
# We advise 3.12 at least, but 3.7 is authorized since it's the default version on current debian stable.
cmake_minimum_required(VERSION 3.7)

# policy https://cmake.org/cmake/help/git-stage/policy/CMP0074.html
if(${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.12")
  cmake_policy(SET CMP0074 NEW)
endif()

# Set cmake modules directory (i.e. the one which contains all
# user-defined FindXXX.cmake files among other things)
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)
# Force out-of-source build
if ("${CMAKE_SOURCE_DIR}" MATCHES "${CMAKE_BINARY_DIR}")
  message (SEND_ERROR "In source building not supported (not recommanded indeed). You need to :
    * cleanup your source directory :  \"rm -rf ./CMakeFiles/ ./CMakeCache.txt\"
    * try configure process again in a new directory
    (e.g. mkdir <anywhere>/build ; cd <anywhere>/build ; cmake ${CMAKE_SOURCE_DIR}) ...")
  return()
endif()

# If not given, turn build type to release mode.
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: None Debug Release." FORCE)
endif()

# ------- FCLib setup -------

# User defined options
option(FCLIB_WITH_MERIT_FUNCTIONS "enable merit functions. Default = ON" OFF)
option(FCLIB_HEADER_ONLY "static interface. Default = ON" ON)
option(VERBOSE_MODE "enable verbose mode for cmake exec. Default = ON" ON)
option(USE_MPI "compile and link fclib with mpi when this mode is enable. Default = ON" OFF)
option(BUILD_SHARED_LIBS "Enable dynamic library build, default = ON" ON)
option(WITH_TESTS "Enable testing. Default = ON" ON)
option(FORCE_SKIP_RPATH "Do not build shared libraries with rpath. Useful only for packaging. Default = OFF" OFF)
option(USE_SYSTEM_SUITESPARSE "Use the system-installed SuiteSparse library for CXSparse if one is found." ON)
option(SKIP_PKGCONFIG "Do not configure or install the pkg-config file." OFF)
option(HARDCODE_NOT_HEADER_ONLY "Pre-define as 'not header-only' in the installed header." OFF)

if(HARDCODE_NOT_HEADER_ONLY AND FCLIB_HEADER_ONLY)
  message(FATAL_ERROR
    "HARDCODE_NOT_HEADER_ONLY=${HARDCODE_NOT_HEADER_ONLY} "
    "and FCLIB_HEADER_ONLY=${FCLIB_HEADER_ONLY} are inconsistent.")
endif()

if(FCLIB_WITH_MERIT_FUNCTIONS AND FCLIB_HEADER_ONLY)
  message(FATAL_ERROR
    "FCLIB_WITH_MERIT_FUNCTIONS=${FCLIB_WITH_MERIT_FUNCTIONS} "
    "and FCLIB_HEADER_ONLY=${FCLIB_HEADER_ONLY} are inconsistent.")
endif()

if(HARDCODE_NOT_HEADER_ONLY)
  set(OPTDEFS FCLIB_NOT_HEADER_ONLY)
  if(FCLIB_WITH_MERIT_FUNCTIONS)
    list(APPEND OPTDEFS FCLIB_WITH_MERIT_FUNCTIONS)
  endif()
  set(DEFS)
  foreach(_D IN LISTS OPTDEFS)
    set(DEFS "${DEFS}\\n#ifndef ${_D}\\n#define ${_D}\\n#endif\\n")
  endforeach()
  add_custom_target(fclib_h
    COMMAND cat ${CMAKE_CURRENT_SOURCE_DIR}/src/fclib.h
      | sed 's,/\\*@ CONFIG @\\*/,${DEFS},'
      | sed '/@@/,/@@/d'
      | sed 's/FCLIB_STATIC //' >fclib.h
    BYPRODUCTS ${CMAKE_CURRENT_BINARY_DIR}/fclib.h
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/src/fclib.h
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Customising fclib.h")
	set(EXTRA_TARGETS fclib_h)
endif()


# cmake project name
set(PROJECT_NAME fclib)


# ============= Project setup =============
project(${PROJECT_NAME} C)
include(FClibVersion)
include(fclib_setup)

if(FCLIB_HEADER_ONLY)
  add_library(fclib INTERFACE)
  set(LIB_SCOPE INTERFACE)
  target_compile_definitions(fclib INTERFACE FCLIB_HEADER_ONLY)
else()
  # --- Build fclib as a library ---
  message("Build fclib library ...")
  if(BUILD_SHARED_LIBS) # shared library
    add_library(fclib SHARED src/fclib.c)
  else() # static library
    add_library(fclib STATIC src/fclib.c)
  endif()
  set(LIB_SCOPE PUBLIC)

  if(FCLIB_WITH_MERIT_FUNCTIONS)
    target_compile_definitions(fclib PUBLIC FCLIB_WITH_MERIT_FUNCTIONS)
  endif()
  
  set_target_properties(fclib PROPERTIES
    OUTPUT_NAME "fclib"
    VERSION "${${PACKAGE_NAME}_SOVERSION}"
    SOVERSION  "${${PACKAGE_NAME}_SOVERSION_MAJOR}"
    LINKER_LANGUAGE C)

  # MSVC extra conf
  if(MSVC)
    option(USING_HDF5_DLLs "WIN ONLY: turn on if the shared library of HDSL is linked" ON)
    if(USING_HDF5_DLLs)
      target_compile_definitions(fclib PRIVATE H5_BUILT_AS_DYNAMIC_LIB)
    endif()
    target_compile_definitions(fclib PRIVATE "FCLIB_APICOMPILE=__declspec( dllexport )")
    target_compile_definitions(fclib PRIVATE _CRT_SECURE_NO_WARNINGS)
  endif()

  # - SuiteSparse -
  if(FCLIB_WITH_MERIT_FUNCTIONS)
    find_package(SuiteSparse REQUIRED COMPONENTS CXSparse)
    target_link_libraries(${PROJECT_NAME} PRIVATE SuiteSparse::CXSparse)
  endif()

  
endif()


  # --- dependencies ---

  # - mpi -
  if(WITH_MPI)
    find_package(MPI REQUIRED)
    target_include_directories(${PROJECT_NAME} ${LIB_SCOPE} ${MPI_C_INCLUDE_DIRS})
    target_link_libraries(${PROJECT_NAME} ${LIB_SCOPE} ${MPI_C_LIBRARIES})
  endif()
  
  # - hdf5 -
  find_package(HDF5  COMPONENTS C HL REQUIRED)
  target_include_directories(${PROJECT_NAME} ${LIB_SCOPE} ${HDF5_C_INCLUDE_DIRS})
  target_link_libraries(${PROJECT_NAME} ${LIB_SCOPE} ${HDF5_C_LIBRARIES})
  target_link_libraries(${PROJECT_NAME} ${LIB_SCOPE} ${HDF5_HL_LIBRARIES})

  # 
  # --- install lib --
  install(TARGETS fclib
    EXPORT fclibTargets
    RUNTIME DESTINATION bin
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    INCLUDES DESTINATION include
    )
 
# --- Install headers ---
if(HARDCODE_NOT_HEADER_ONLY)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/fclib.h DESTINATION include)
else()
  install(FILES src/fclib.h DESTINATION include) 
endif()
target_include_directories(fclib INTERFACE $<INSTALL_INTERFACE:include>)
if(EXTRA_TARGETS)
  add_dependencies(fclib ${EXTRA_TARGETS})
endif()

# ============= Doc and website =============
if(WITH_DOCUMENTATION)
  include(FCLibDoc)
endif()


# ============= Fclib Package configuration =============
# i.e. what should be generated/configured at install.
include(FClibPackageSetup)

#  ============= Tests =============
if(WITH_TESTS)
  enable_testing()
  add_executable(fctest1 src/tests/fctst.c)
  add_test(fctest1 fctest1)
  target_link_libraries(fctest1 PRIVATE fclib)
  target_include_directories(fctest1 PRIVATE src)
  if(FORCE_SKIP_RPATH)
    set_tests_properties(fctest1 PROPERTIES ENVIRONMENT LD_LIBRARY_PATH=${CMAKE_CURRENT_BINARY_DIR})
  endif()

  if(FCLIB_WITH_MERIT_FUNCTIONS)
    target_link_libraries(fctest1 PRIVATE SuiteSparse::CXSparse)
    add_executable(fctest_merit src/tests/fctst_merit.c)
    add_test(fctest_merit fctest_merit)
    target_link_libraries(fctest_merit PRIVATE fclib)
    target_include_directories(fctest_merit PRIVATE src)
    target_link_libraries(fctest_merit PRIVATE SuiteSparse::CXSparse)
    if(FORCE_SKIP_RPATH)
      set_tests_properties(fctest_merit PROPERTIES ENVIRONMENT LD_LIBRARY_PATH=${CMAKE_CURRENT_BINARY_DIR})
    endif()
    configure_file(
      ${CMAKE_CURRENT_SOURCE_DIR}/src/tests/data/local_problem_test.hdf5
      ${CMAKE_CURRENT_BINARY_DIR} COPYONLY)
  endif()
endif()


message(STATUS "====================== Summary ======================")
message(STATUS " Compiler : ${CMAKE_C_COMPILER}")
message(STATUS " Sources are in : ${CMAKE_SOURCE_DIR}")
message(STATUS " Project uses MPI : ${USE_MPI}")
message(STATUS " Project uses HDF5 : ${HDF5_LIBRARIES}")
message(STATUS " Project will be installed in ${CMAKE_INSTALL_PREFIX}")
message(STATUS "====================== ======= ======================")

=== doc/latex/Makefile ===
all: refman.pdf

pdf: refman.pdf

refman.pdf: clean refman.tex
	pdflatex refman
	makeindex refman.idx
	pdflatex refman
	latex_count=5 ; \
	while egrep -s 'Rerun (LaTeX|to get cross-references right)' refman.log && [ $$latex_count -gt 0 ] ;\
	    do \
	      echo "Rerunning latex...." ;\
	      pdflatex refman ;\
	      latex_count=`expr $$latex_count - 1` ;\
	    done
	makeindex refman.idx
	pdflatex refman


clean:
	rm -f *.ps *.dvi *.aux *.toc *.idx *.ind *.ilg *.log *.out *.brf *.blg *.bbl refman.pdf

=== debian/changelog ===
fclib (3.1.0+dfsg-3build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 18:14:03 +0000

fclib (3.1.0+dfsg-3build1) noble; urgency=medium

  * No-change rebuild against libhdf5-103-1t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 13 Mar 2024 17:55:14 +0000

fclib (3.1.0+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Fix autopkgtest regression due to CMake warning (Closes: #1040718)

 -- Timo Röhling <roehling@debian.org>  Sun, 23 Jul 2023 21:28:17 +0200

=== debian/rules ===
--- 
+++ 
@@ -22,4 +22,4 @@
 	  -DFCLIB_WITH_MERIT_FUNCTIONS=ON \
 	  -DFCLIB_HEADER_ONLY=OFF \
 	  -DHARDCODE_NOT_HEADER_ONLY=ON \
-	  -DINSTALL_CMAKE_DIR=$(LIBDIR)/cmake/FCLib
+	  -DINSTALL_CMAKE_DIR=$(LIBDIR)/cmake/FCLIB

=== debian/watch ===
version=4
opts=repacksuffix=+dfsg,dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$// \
  https://github.com/FrictionalContactLibrary/fclib/releases .*/v?(\d+\.\d+.\d+)\.tar\.gz
